const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const territoryVersionService = require('./territoryVersion.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/filter', authorize(), filter);
router.post('/option', authorize(), option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    territoryVersionService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    territoryVersionService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function filter(req, res, next) {
    territoryVersionService.filter(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    territoryVersionService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    territoryVersionService.count()
        .then(result => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    territoryVersionService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    territoryVersionService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    territoryVersionService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
